/*    
    Copyright (C) 2012 http://software-talk.org/ (developer@software-talk.org)

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package mill.view;

import mill.Controller.MainController;
import mill.Model.OptionObject;

/**
 * This class makes a Frame for some options of the game "Mill".
 * @version 1.0.1
 */
public class OptionFrame extends javax.swing.JFrame {

    /** Creates new form OptionFrame */
    public OptionFrame(MainController ctrl) {
        initComponents();
        this.ctrl = ctrl;
        this.options = ctrl.getOptions();
        init();
    }
    private boolean humanVsHuman;
    private boolean humanVsCom;
    private boolean comVsHuman;
    private boolean diagonalLines;
    private MainController ctrl;
    private OptionObject options;

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        playerOptionsButtonGroup = new javax.swing.ButtonGroup();
        jLabel1 = new javax.swing.JLabel();
        okButton = new javax.swing.JButton();
        cancelButton = new javax.swing.JButton();
        jLabel2 = new javax.swing.JLabel();
        numberOfStonesInput = new javax.swing.JTextField();
        jLabel3 = new javax.swing.JLabel();
        diagonalCheckBox = new javax.swing.JCheckBox();
        jLabel4 = new javax.swing.JLabel();
        jLabel5 = new javax.swing.JLabel();
        jLabel6 = new javax.swing.JLabel();
        jLabel7 = new javax.swing.JLabel();
        humanVsHumanButton = new javax.swing.JCheckBox();
        humanVsComButton = new javax.swing.JCheckBox();
        ComVsHumanButton = new javax.swing.JCheckBox();

        setDefaultCloseOperation(javax.swing.WindowConstants.DO_NOTHING_ON_CLOSE);
        setAlwaysOnTop(true);
        setResizable(false);
        setUndecorated(true);

        jLabel1.setText("Game settings:");

        okButton.setText("Save");
        okButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                okButtonActionPerformed(evt);
            }
        });

        cancelButton.setText("Cancel");
        cancelButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancelButtonActionPerformed(evt);
            }
        });

        jLabel2.setText("Number of Stones:");
        jLabel2.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));

        numberOfStonesInput.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));

        jLabel3.setText("Diagonal lines:");
        jLabel3.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));

        diagonalCheckBox.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        diagonalCheckBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                diagonalCheckBoxActionPerformed(evt);
            }
        });

        jLabel4.setText("Player settings:");

        jLabel5.setText("Human vs. Human:");
        jLabel5.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));

        jLabel6.setText("Human vs. Ai:");
        jLabel6.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));

        jLabel7.setText("Ai vs. Human:");
        jLabel7.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));

        playerOptionsButtonGroup.add(humanVsHumanButton);
        humanVsHumanButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                humanVsHumanButtonActionPerformed(evt);
            }
        });

        playerOptionsButtonGroup.add(humanVsComButton);
        humanVsComButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                humanVsComButtonActionPerformed(evt);
            }
        });

        playerOptionsButtonGroup.add(ComVsHumanButton);
        ComVsHumanButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ComVsHumanButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel1, javax.swing.GroupLayout.PREFERRED_SIZE, 113, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                        .addGroup(javax.swing.GroupLayout.Alignment.LEADING, layout.createSequentialGroup()
                            .addComponent(jLabel2, javax.swing.GroupLayout.PREFERRED_SIZE, 99, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                            .addComponent(numberOfStonesInput, javax.swing.GroupLayout.PREFERRED_SIZE, 37, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGroup(javax.swing.GroupLayout.Alignment.LEADING, layout.createSequentialGroup()
                            .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                                .addComponent(okButton)
                                .addComponent(jLabel3, javax.swing.GroupLayout.PREFERRED_SIZE, 95, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                            .addComponent(diagonalCheckBox, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))))
                .addGap(28, 28, 28)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel4, javax.swing.GroupLayout.PREFERRED_SIZE, 126, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(jLabel5, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(jLabel6, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(jLabel7, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(cancelButton))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(ComVsHumanButton)
                            .addComponent(humanVsComButton)
                            .addComponent(humanVsHumanButton))))
                .addContainerGap(130, Short.MAX_VALUE))
        );

        layout.linkSize(javax.swing.SwingConstants.HORIZONTAL, new java.awt.Component[] {jLabel5, jLabel6, jLabel7});

        layout.linkSize(javax.swing.SwingConstants.HORIZONTAL, new java.awt.Component[] {jLabel2, jLabel3});

        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1, javax.swing.GroupLayout.PREFERRED_SIZE, 29, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel4, javax.swing.GroupLayout.PREFERRED_SIZE, 22, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(jLabel5, javax.swing.GroupLayout.DEFAULT_SIZE, 27, Short.MAX_VALUE)
                        .addComponent(humanVsHumanButton))
                    .addComponent(jLabel2, javax.swing.GroupLayout.DEFAULT_SIZE, 27, Short.MAX_VALUE)
                    .addComponent(numberOfStonesInput, javax.swing.GroupLayout.PREFERRED_SIZE, 26, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(jLabel6, javax.swing.GroupLayout.PREFERRED_SIZE, 27, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel3, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 27, Short.MAX_VALUE)
                            .addComponent(diagonalCheckBox, javax.swing.GroupLayout.Alignment.TRAILING))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(jLabel7, javax.swing.GroupLayout.PREFERRED_SIZE, 29, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(ComVsHumanButton))
                        .addGap(46, 46, 46)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(cancelButton)
                            .addComponent(okButton)))
                    .addComponent(humanVsComButton))
                .addContainerGap(75, Short.MAX_VALUE))
        );

        layout.linkSize(javax.swing.SwingConstants.VERTICAL, new java.awt.Component[] {jLabel5, jLabel6, jLabel7});

        layout.linkSize(javax.swing.SwingConstants.VERTICAL, new java.awt.Component[] {jLabel2, jLabel3});

        pack();
    }// </editor-fold>//GEN-END:initComponents
    /**
     * the button to set and save the choosen options.
     * @param evt 
     */
    private void okButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_okButtonActionPerformed
       
        if (setSettings()) {
            this.dispose();
            ctrl.saveOptions();
            ctrl.setGuiEnabled();
        }
        
    }//GEN-LAST:event_okButtonActionPerformed
    /**
     * the button to close the option frame. No option will be change.
     * @param evt 
     */
    private void cancelButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cancelButtonActionPerformed
        
        this.dispose();
        ctrl.setGuiEnabled();
        
    }//GEN-LAST:event_cancelButtonActionPerformed
    /**
     * swichts of the game should have diagonal lines.
     * @param evt 
     */
    private void diagonalCheckBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_diagonalCheckBoxActionPerformed
   
        diagonalLines = !diagonalLines;
        
    }//GEN-LAST:event_diagonalCheckBoxActionPerformed
    /**
     * select player one as human, also player two.
     * @param evt 
     */
    private void humanVsHumanButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_humanVsHumanButtonActionPerformed

        humanVsHuman = true;
        comVsHuman = false;
        humanVsCom = false;

    }//GEN-LAST:event_humanVsHumanButtonActionPerformed
    /**
     * select player on as human and player two as ai.
     * @param evt 
     */
    private void humanVsComButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_humanVsComButtonActionPerformed

        humanVsHuman = false;
        comVsHuman = false;
        humanVsCom = true;

    }//GEN-LAST:event_humanVsComButtonActionPerformed
    /**
     * select player on as ai and player two as human.
     * @param evt 
     */
    private void ComVsHumanButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_ComVsHumanButtonActionPerformed

        humanVsHuman = false;
        comVsHuman = true;
        humanVsCom = false;

    }//GEN-LAST:event_ComVsHumanButtonActionPerformed
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JCheckBox ComVsHumanButton;
    private javax.swing.JButton cancelButton;
    private javax.swing.JCheckBox diagonalCheckBox;
    private javax.swing.JCheckBox humanVsComButton;
    private javax.swing.JCheckBox humanVsHumanButton;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JTextField numberOfStonesInput;
    private javax.swing.JButton okButton;
    private javax.swing.ButtonGroup playerOptionsButtonGroup;
    // End of variables declaration//GEN-END:variables

    /**
     * inits all settings. It select the right buttons and set the current
     * setted number in the textarea.
     */
    private void init() {
        numberOfStonesInput.setText("" + options.getNumberOfStones());
        boolean isP1Com = options.isPlayerOneComputer();
        boolean isP2Com = options.isPlayerTwoComputer();
        if (!isP1Com && !isP2Com) {
            selectHumanVsHumanButton();
        } else if (!isP1Com && isP2Com) {
            selectHumanVsComButton();
        } else if (isP1Com && !isP2Com) {
            selectComVsHumanButton();
        }
        selectSwitchDiagonalButton(options.isPlayWithDiagonalLines());
    }

    /**
     * set the settings to the maincontroller.
     * @return true if the settings could be changed, else not.
     */
    private boolean setSettings() {
        if (ctrl.setNumberOfStones(numberOfStonesInput.getText())) {
            if (humanVsHuman) {
                options.setPlayerOneAsComputer(false);
                options.setPlayerTwoAsComputer(false);
            } else if (humanVsCom) {
                options.setPlayerOneAsComputer(false);
                options.setPlayerTwoAsComputer(true);
            } else if (comVsHuman) {
                options.setPlayerOneAsComputer(true);
                options.setPlayerTwoAsComputer(false);
            }
            options.setPlayWithDiagonalLines(diagonalLines);
            return true;
        } else { // do nothing
            return false;
        }
    }

    /**
     * select or deselect the button which switchses the rule
     * for diagonal gaming on and off.
     * @param isSelected true if button is selected, else false.
     */
    public void selectSwitchDiagonalButton(boolean isSelected) {
        diagonalCheckBox.setSelected(isSelected);
    }

    /**
     * set the <code>humanVsHumanButton</code> selected,
     * and the other player buttons not selected.
     */
    public void selectHumanVsHumanButton() {
        playerOptionsButtonGroup.setSelected(humanVsHumanButton.getModel(), true);
    }

    /**
     * set the <code>comVsHumanButton</code> selected,
     * and the other player buttons not selected.
     */
    public void selectComVsHumanButton() {
        playerOptionsButtonGroup.setSelected(ComVsHumanButton.getModel(), true);
    }

    /**
     * set the <code>humanVsComButton</code> selected,
     * and the other player buttons not selected.
     */
    public void selectHumanVsComButton() {
        playerOptionsButtonGroup.setSelected(humanVsComButton.getModel(), true);
    }
}
